dnl -*- Mode: Autoconf; -*-

dnl BMP_CHECK_BOOST_SMART_PTR([ACTION-IF-FOUND], [ACTION-IF-NOT-FOUND])
AC_DEFUN([BMP_CHECK_BOOST_SMART_PTR],
    [AC_MSG_CHECKING([for Boost smart pointer library])
     AC_TRY_COMPILE(
         [#include <boost/shared_ptr.hpp>
          #include <boost/scoped_ptr.hpp>],
         [boost::shared_ptr<int> ptr  (new int);
          boost::scoped_ptr<int> ptr2 (new int);],
         [AC_MSG_RESULT([yes])
          $1],
         [AC_MSG_RESULT([not found])
          $2])
    ]
)

dnl BMP_CHECK_BOOST_STRING_ALGO([ACTION-IF-FOUND], [ACTION-IF-NOT-FOUND])
AC_DEFUN([BMP_CHECK_BOOST_STRING_ALGO],
    [AC_MSG_CHECKING([for Boost string algorithm library])
     AC_TRY_COMPILE(
         [#include <boost/algorithm/string.hpp>],
         [// FIXME: write something...],
         [AC_MSG_RESULT([yes])
          $1],
         [AC_MSG_RESULT([not found])
          $2])
    ]
)

dnl BMP_CHECK_BOOST_FILESYSTEM([ACTION_IF_FOUND], [ACTION-IF-NOT-FOUND])
AC_DEFUN([BMP_CHECK_BOOST_FILESYSTEM],
    [AC_MSG_CHECKING([for Boost filesystem library])
     LIBS="$LIBS -lboost_filesystem"
     AC_TRY_COMPILE(
         [#include <boost/filesystem/path.hpp>
          #include <boost/filesystem/operations.hpp>],
         [namespace fs = boost::filesystem;
          fs::path path = fs::path ("directory") / "file";],
         [AC_MSG_RESULT([yes])
          $1],
         [AC_MSG_RESULT([not found])
          $2])
    ]
)

dnl BMP_CHECK_BOOST_FORMAT_STR([ACTION-IF-FOUND], [ACTION-IF-NOT-FOUND])
AC_DEFUN([BMP_CHECK_BOOST_FORMAT_STR],
    [AC_MSG_CHECKING([for Boost format string library])
     AC_TRY_COMPILE(
         [#include <iostream>
          #include <boost/format.hpp>],
         [std::cout << boost::format ("%d %s") % 1 % "Hello"],
         [AC_MSG_RESULT([yes])
          $1],
         [AC_MSG_RESULT([not found])
          $2])
    ]
)
