//  BMPx - The Dumb Music Player
//  Copyright (C) 2005 BMPx development team.
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
//  --
//
//  The BMPx project hereby grants permission for non-GPL compatible GStreamer
//  plugins to be used and distributed together with GStreamer and BMPx. This
//  permission is above and beyond the permissions granted by the GPL license
//  BMPx is covered by.

#ifndef BMP_TRACK_INFO_HPP
#define BMP_TRACK_INFO_HPP

#include <gtkmm.h>
#include <libglademm.h>
#include <boost/optional.hpp>

#include "database.hpp"
#include "library.hpp"
#include "lyrics.hpp"

namespace Bmp
{
  class EventBoxXDS;

  class TrackInfo
      : public Gtk::Window
  {
  public:

      TrackInfo (BaseObjectType                        *cobject,
                 const Glib::RefPtr<Gnome::Glade::Xml> &xml);

      static TrackInfo *
      create ();

      ~TrackInfo ();

      void
      show (const Glib::ustring& uri);

      void
      clear ();

  private:

      void
      check_update (Glib::ustring		 pkey,
		    Bmp::Library::UpdateTrack    track);

      void
      ok_clicked ();

      void
      get_lyrics ();

      void
      on_drag_start (int n_tracks);
      void
      on_drag_step  ();
      void
      on_drag_end   ();

      Glib::RefPtr<Gnome::Glade::Xml>	ref_xml;
      Bmp::Lyrictracker		       *tracker;
      std::string			path_image_default;

      Gtk::Button   *ok;
      Gtk::Image    *image;
      Gtk::TextView *lyrics;

      Gtk::Button   *b_lyrics;

      Gtk::Entry    *entry_artist;
      Gtk::Entry    *entry_album;
      Gtk::Entry    *entry_title;
      Gtk::Entry    *entry_file;
      Gtk::Entry    *entry_comment;
      Gtk::Entry    *entry_genre;

      Gtk::Label    *label_date;
      Gtk::Label    *label_track;
      Gtk::Label    *label_bitrate;
      Bmp::EventBoxXDS *ebox;

      boost::optional<Glib::ustring> location;
      boost::optional<Glib::ustring> artist;
      boost::optional<Glib::ustring> album;
      Bmp::Library::Track track;

      int n_drag_tracks;
      int n_drag_current;
      Gtk::ProgressBar	*copy_progress;
      
  };

} // namespace Bmp

#endif // BMP_TRACK_INFO_HPP

